# From Imports
from sarge import run

# Exception Classes
class Error(Exception):
    pass


class NoSize(Error):
    pass


class tests:
    def __init__(self, size: str):
        """
            Variable "size" takes in a string of the proposed size of the test files; this can be "small", "medium", "large", or "extralarge".
        """
        self.size: str = size

    def txt(self):
        """
            Create text test files using the "base64" program; sizes are:
            - small:      20 files, 10 bytes
            - medium:     20 files, 10 kilobytes
            - large:      10 files, 10 megabytes
            - extralarge: 2  files, 1  gigabyte
        """
        _: Callable[
            ..., str
        ] = lambda size, file: f"base64 /dev/urandom | head -c {size} > {file}.txt"
        if self.size == "small":
            for i in range(1, 21):
                run(_(10, i))
        elif self.size == "medium":
            for i in range(1, 21):
                run(_(10000, i))
        elif self.size == "large":
            for i in range(1, 11):
                run(_(10000000, i))
        elif self.size == "extralarge":
            for i in range(1, 3):
                run(_(1000000000, i))
        else:
            raise NoSize(f"Sorry, no size {self.size}")

    def bin(self):
        """
            Create binary test files using the "fallocate" program; sizes are:
            - small:      20 files, 10 bytes
            - medium:     20 files, 10 kilobytes
            - large:      10 files, 10 megabytes
            - extralarge: 2  files, 1  gigabyte
        """
        _: Callable[
            ..., str
        ] = lambda size, file: f"fallocate -l 10{size} {file}.bin"
        if self.size == "small":
            for i in range(1, 21):
                run(_("", i))
        elif self.size == "medium":
            for i in range(1, 21):
                run(_("K", i))
        elif self.size == "large":
            for i in range(1, 11):
                run(_("M", i))
        elif self.size == "extralarge":
            for i in range(1, 3):
                run(_("G", i))
        else:
            raise NoSize(f"Sorry, no size {self.size}")
