# From Imports
from os import name as osName, path as osPath, sep as osSep
from typing import List, Callable

# Local Imports
from nanite import nanite

fullpath: Callable[..., str] = nanite().fullpath


class joins:
    def __init__(self, pathList: List[str]):
        """
            Variable "pathList" takes an iterable (list, tuple, generator, etc.) of paths
        """
        self.pathList: List[str] = map(fullpath, pathList)

    def pathName(self) -> List[str]:
        """
            Return the class' list of paths joined by periods instead of slashes
        """
        return [
            i.replace(":", "").replace(osSep, ".").lstrip(".")
            for i in self.pathList
        ]

    def findExcl(self) -> str:
        """
            Return the class' list of paths joined by the "find" command's path exlusion format
        """
        return f'-path {" -o -path ".join(self.pathList)}'
