# Imports
import os

# From Imports
from typing import List, Callable, Any


class Error(Exception):
    pass


class noFileDir(Error):
    pass


class currentDirError(Error):
    pass


class nanite:
    def __init__(self):
        pass

    def fullpath(
        self,
        *args: List[str],
        currentDir: int = 0,
        check: bool = False,
    ) -> str:
        """
            Credits: https://stackoverflow.com/questions/43333640/python-os-path-realpath-for-symlink-in-windows/48416561#48416561
            Answer By: https://stackoverflow.com/users/1847677/%c3%89tienne

            Modified by Jeet Ray <titaniumfiles@outlook.com>
        """
        path: Callable[..., Any] = os.path
        _path: str = path.expandvars(
            path.expanduser(path.join(*args))
        )
        if not 0 <= currentDir <= 2:
            raise currentDirError(
                f"Sorry! Invalid value {currentDir}; current directory parameter must be between 0 and 2!"
            )
        elif currentDir == 0:
            if os.name != "nt":
                _path = f"/{_path}"
        elif currentDir == 1:
            _path = f"./{_path}"

        def _checkAndReturn(_):
            if check:
                if path.isdir(_) or path.isfile(_):
                    return _
                else:
                    raise noFileDir(
                        f'Sorry! "{_}" does not appear to be a file or a directory!'
                    )
            else:
                return _

        if os.name == "nt":
            return _checkAndReturn(
                _path
                if not path.islink(_path)
                else os.readlink(_path)
            )
        else:
            return _checkAndReturn(path.realpath(_path))
